/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module common.cacheresolve;

private import std.base64;
private import std.path;
private import common.environment;

private void toValidPath(char[] path)
{
	for (int i = 0; i < path.length; ++i) {
		if (path[i] == '=') {
			path[i] = '_';
		} else if (path[i] == '/') {
			path[i] = '-';
		} else if (path[i] == '+') {
			path[i] = ' ';
		}
	}
}


char []cacheResolve(ubyte[] hash, Configuration config)
{
		uint	blen		= std.base64.encodeLength(hash.length);
		char[]	name		= new char[blen];
		
		name = std.base64.encode(cast(char[])hash, name);
		toValidPath(name);
		
		return config.cacheFolder ~ std.path.sep ~ name ~ ".db";
}

