﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module common.packet;

// コマンド転送用

private import std.socket;
private import pes.net.winny.command;
private import pes.system.all;
private import pes.arraybox;
private import common.task;
private import common.nodetable;
private import common.connectiontable;


class CommandSendOption
{
	enum Target {
		DownstreamConnection,		// 下流リンクノード
		DownstreamConnectionAll,	// 下流リンク全ノード
		UpstreamConnection,			// 上流リンクノード
		UpstreamConnectionAll,		// 上流リンク全ノード
		AllConnection,				// 全リンク
		AllConnectionAll,			// 全リンク全ノード
		NewLink,					// 新規ノード(新規接続あり)
	}
	Target target;
	InternetAddress		sendTo;	// 指定アドレス (ALL系は無視)
	
	this(Target target, InternetAddress send_to)
	{
		this.target	= target;
		sendTo		= send_to;
	}
}

class ReceivedCommand
{
	this(NyRawCommand command, NodeDetails node, Connection connection = null)
	{
		this.command = command;
		this.node = node;
		this.connection = connection;
	}
	this(){}
	
	NyRawCommand	command;
	NodeDetails		node;
	Connection		connection;
}

ArrayBox!(Object) makeSendCommandRequest(CommandSendOption option, NyCommand command)
in {
	assert(option !is null);
	assert(command !is null);
}
body {
	ArrayBox!(Object) array;
	Object[] packet_set = new Object[2];
	
	packet_set[0] = option;
	packet_set[1] = command;
	
	array = new ArrayBox!(Object)(packet_set);
	
	return array;
}

void unboxCommand(Object pack, out CommandSendOption option, out NyCommand command)
{
	ArrayBox!(Object) array = cast(ArrayBox!(Object))pack;
	
	Object[] packet = array.array;
	option = cast(CommandSendOption)packet[0];
	command = cast(NyCommand)packet[1];
	
}

