/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.byteorder;

private import std.intrinsic;

ushort hostToNetwork16(ushort hostbyte)
{
	version(LittleEndian) {
		return (hostbyte >>> 8) | (hostbyte << 8);
	} else version(BigEndian) {
		return hostbyte;
	} else {
		static assert(0); // unknown byte order
	}
}

ushort networkToHost16(ushort netbyte)
{
	return hostToNetwork16(netbyte);
}

uint hostToNetwork32(uint hostbyte)
{
	version(LittleEndian) {
		return bswap(hostbyte);
	} else version(BigEndian) {
		return hostbyte;
	} else {
		static assert(0); // unknown byte order
	}
}

uint networkToHost32(uint netbyte)
{
	return hostToNetwork32(netbyte);
}


