/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
/**
 * 
 * T[oNCAgf̂߂
 * ėpIquery/response֐
 * 
 */
 
module net.qr;

private import std.socket;

/*
 * TCP
 *
 */
void [] qrtcp(Address connect_to,
			void [] request, size_t response_size_max,
			int timeup_sec = 0)
{
	ubyte [] response = new ubyte[response_size_max];
	auto TcpSocket 	socket = new TcpSocket(connect_to);
	int 			receive_len;
	
	socket.send(request);
	socket.shutdown(SocketShutdown.SEND);
	
	if (timeup_sec == 0) {
		receive_len = socket.receive(response);
	} else {
		SocketSet 	socket_set = new SocketSet(1);
		timeval 	timeup;
		
		timeup.seconds = timeup_sec;
		socket_set.add(socket);
		
		/+ polling +/
		if (socket.select(socket_set, null, null, &timeup) <= 0) {
			// timeout, or error
			receive_len = 0;
		} else {
			receive_len = socket.receive(response);
		}
	}
	socket.shutdown(SocketShutdown.RECEIVE);
	
	socket.close();
	
	response.length = (receive_len > 0) ? receive_len: 0;
	
	return response;
}

/**
 * UDP
 *
 */
void qrudp(Address send_to,
			void [] request, void [] response,
			int timeup_sec = 0)
{
	auto UdpSocket 	socket = new UdpSocket();
	Address			receive_from;
	int				receive_len;
	
	socket.sendTo(request, send_to);
	
	if (timeup_sec == 0) {
		do {
			receive_len = socket.receiveFrom(response, receive_from);
			if (receive_len < 0) {
				// error
				break;
			}
		} while (send_to != receive_from);
	} else {
		SocketSet	socket_set = new SocketSet(1);
		timeval		timeup;
		
		timeup.seconds = timeup_sec;
		socket_set.add(socket);
		
		do {
			/+ polling +/
			if (socket.select(socket_set, null, null, &timeup) <= 0) {
				// timeout, or error
				receive_len = 0;
				break;
			}
			receive_len = socket.receiveFrom(response, receive_from);
		} while (send_to != receive_from);
	}
	
	socket.close();
	
	if (receive_len <= 0) {
		receive_len = 0;
	}
	response.length = receive_len;
}

debug(pes_net_qr)
{
	import std.stdio;
	import std.socket;
	
	int main()
	{
		char [] 	request;
		char [] 	response;
		Address		server;
		
		// HTTP/1.0
		server		= new InternetAddress("www.google.com", 80);
		request		= "GET / HTTP/1.0\x0d\x0a\x0d\x0a";
		response 	= cast(char [])qrtcp(server, request, 4092);
		writef("--HTTP/1.0\nlength = %d\n--\n%s\n", response.length, response);
		
		// WHOIS/NICNAME
		server		= new InternetAddress("whois.register.com", 43);
		request		= "digitalmars.com\x0d\x0a";
		response	= cast(char [])qrtcp(server, request, 4092, 2);
		writef("--WHOIS/NICNAME\nlength = %d\n--\n%s\n", response.length, response);
		
		return 0;
	}
}

